<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

$template->set_filenames(array('plugins' => PLUGINSMANAGER_PATH . 'template/plugins_update.tpl'));

//-----------------------------------------------------------automatic upgrade
if (isset($_GET['upgrade']) and isset($_GET['plugin']) and !is_adviser())
{
  $plugin_id = $_GET['plugin'];

  if (isset($plugins->db_plugins_by_id[$plugin_id])
    and $plugins->db_plugins_by_id[$plugin_id]['state'] == 'active')
  {
    $plugins->perform_action('deactivate', $plugin_id);

    redirect($base_url
      . '&upgrade=' . $_GET['upgrade']
      . '&plugin=' . $plugin_id
      . '&reactivate=true');
  }

  $upgrade_status = $plugins->extract_plugin_files('upgrade', $_GET['upgrade'], $plugin_id);

  if (isset($_GET['reactivate']))
  {
    $plugins->perform_action('activate', $plugin_id);
  }
  redirect($base_url.'&plugin='.$plugin_id.'&upgradestatus='.$upgrade_status);
}

//--------------------------------------------------------------upgrade result
if (isset($_GET['upgradestatus']) and isset($_GET['plugin']))
{
	switch ($_GET['upgradestatus'])
	{
	case 'ok':
		array_push($page['infos'], sprintf(l10n('pm_upgrade_ok'), $plugins->fs_plugins[$_GET['plugin']]['name']));
		break;

	case 'temp_path_error':
		array_push($page['errors'], l10n('pm_temp_path_error'));	
		break;
	
	case 'dl_archive_error':
		array_push($page['errors'], l10n('pm_dl_archive_error'));	
		break;

	case 'archive_error':
		array_push($page['errors'], l10n('pm_archive_error'));	
		break;

	default:
		array_push($page['errors'], sprintf(l10n('pm_extract_error'), $_GET['upgradestatus']));	
	}
}

// +-----------------------------------------------------------------------+
// |                     start template output                             |
// +-----------------------------------------------------------------------+
$plugins->get_server_plugins();

if ($plugins->server_plugins !== false)
{
	$num1 = 0;
	$num2 = 0;
	$num3 = 0;
	foreach($plugins->fs_plugins as $plugin_id => $fs_plugin)
	{
		if (isset($fs_plugin['extension']) and isset($plugins->server_plugins[$fs_plugin['extension']]))
		{
			$plugin_info = $plugins->server_plugins[$fs_plugin['extension']];
			
			$ext_desc = nl2br(htmlspecialchars(strip_tags($plugin_info['ext_description'])));
			
			$ver_desc = sprintf(l10n('pm_description'),
							$plugin_info['version'],
							date('Y-m-d', $plugin_info['date']),
							nl2br(htmlspecialchars(strip_tags($plugin_info['description']))));
		
			if ($plugin_info['version'] == $fs_plugin['version'])
			{
				// Le plugin est  jour
				$template->assign_block_vars('plugins_uptodate.uptodate',
							array('URL' => $fs_plugin['uri'],
								'NAME' => $fs_plugin['name'],
								'EXT_DESC' => $ext_desc,
								'VERSION' => $fs_plugin['version'],
								'CLASS' => ($num1++ % 2 == 1) ? 'row2' : 'row1'));
			}
			else
			{
				//Le plugin n'est pas  jour
				$url_auto_update = htmlentities($base_url)
						. '&amp;plugin=' . $plugin_id
						. '&amp;upgrade=%2Fupload%2Fextension-' . $fs_plugin['extension']
						. '%2Frevision-' . $plugin_info['id_revision'] . '%2F' . str_replace(' ', '%20',$plugin_info['url']);
				
				$url_download = PHPWG_URL . '/ext/upload/extension-' . $fs_plugin['extension']
						. '/revision-' . $plugin_info['id_revision']
						. '/' . str_replace(' ', '%20',$plugin_info['url']);
							
				$template->assign_block_vars('plugins_not_uptodate.not_uptodate',
						array('EXT_NAME' => $fs_plugin['name'],
							'EXT_URL' => $fs_plugin['uri'],
							'EXT_DESC' => $ext_desc,
							'VERSION' => $fs_plugin['version'],
							'VERSION_URL' => PHPWG_URL . '/ext/revision_view.php?rid=' . $plugin_info['id_revision'], 
							'NEW_VERSION' => $plugin_info['version'],
							'NEW_VER_DESC' => $ver_desc,
							'URL_UPDATE' => $url_auto_update,
							'URL_DOWNLOAD' => $url_download,
							'CLASS' => ($num2++ % 2 == 1) ? 'row2' : 'row1'));
			}
		}
		else 
		{
			// Impossible de vrifier si le plugin est  jour
			$template->assign_block_vars('plugins_cant_check.cant_check',
					array('NAME' => $fs_plugin['name'],
						'VERSION' => $fs_plugin['version'],
						'CLASS' => ($num3++ % 2 == 1) ? 'row2' : 'row1'));
		}
	}
}
else
{
	array_push($page['errors'], l10n('pm_server_error'));
}
?>